// Copyright E. Kowalski 2010-2015
// License: GPLv2, see file COPYING in the source tar file

package net.frogparrot.kloostermania;

//import android.R;

// Import for kloostermania.R and for the KLOOS_TYPE_* constants

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioGroup;

public class Choosesum extends Activity {

    int modulus = 173;
    int m = 1;
    EditText tv;
    RadioGroup birchkloos;


    private OnClickListener onDone = new OnClickListener() {
        public void onClick(View v) {

            // Hide keyboard
            InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.hideSoftInputFromWindow(v.getApplicationWindowToken(), 0);

            setModulus();
            finish();
        }
    };



    /** Called when the activity is first created. */
    public void onCreate(Bundle savedInstanceState) {
        EditText t;

        super.onCreate(savedInstanceState);

        setContentView(R.layout.choose);

        t = (EditText) findViewById(R.id.field);
        Intent intent = getIntent();
        modulus = intent.getIntExtra("net.frogparrot.kloostermania.modulus", 173);
        t.append(Integer.toString(modulus));
        m = intent.getIntExtra("net.frogparrot.kloostermania.m",1);
        t = (EditText)findViewById(R.id.m);
        t.append(Integer.toString(m));

        RadioGroup rg = (RadioGroup) findViewById(R.id.rg);
        // Select the right radio button
        int typesum = intent.getIntExtra("net.frogparrot.kloostermania.type", Kloostermania.KLOOS_TYPE_KLOOS);

        switch (typesum) {
            case Kloostermania.KLOOS_TYPE_KLOOS:
                rg.check(R.id.kloos);
                break;
            case Kloostermania.KLOOS_TYPE_BIRCH:
                rg.check(R.id.birch);
                break;
            case Kloostermania.KLOOS_TYPE_BOTH:
                rg.check(R.id.both);
                break;
        } // Switch

        Button button = (Button) findViewById(R.id.done);
        button.setOnClickListener(onDone);

        InputMethodManager imm = (InputMethodManager) this.getSystemService(Context.INPUT_METHOD_SERVICE);
        imm.toggleSoftInput(InputMethodManager.SHOW_FORCED, 0);
    }



    public void setModulus () {
        int typesum = Kloostermania.KLOOS_TYPE_KLOOS;
        EditText t;
        int mod,m1,n1;

        t = (EditText) findViewById(R.id.field);
        String st = t.getText().toString();
        mod = Integer.parseInt(st);
        t = (EditText) findViewById(R.id.m);
        m1=Integer.parseInt(t.getText().toString());

        Intent data = new Intent();
        RadioGroup rg = (RadioGroup) findViewById(R.id.rg);
        int checked = rg.getCheckedRadioButtonId();
        switch (checked) {
            case R.id.kloos:
                typesum = Kloostermania.KLOOS_TYPE_KLOOS;
                break;
            case R.id.birch:
                typesum = Kloostermania.KLOOS_TYPE_BIRCH;
                break;
            case R.id.both:
                typesum = Kloostermania.KLOOS_TYPE_BOTH;
                break;
        } // Switch


        data.putExtra("net.frogparrot.kloostermania.modulus", mod);
        data.putExtra("net.frogparrot.kloostermania.m", m1);
        data.putExtra("net.frogparrot.kloostermania.type", typesum);

        setResult(Activity.RESULT_OK, data);
    }


    public void onBackPressed() {
        setModulus();
        finish();
    }


    public void onPause() {
        super.onPause();
        setModulus();
        //finish();
    }

    public void onStop() {
        super.onStop();
        setModulus();
        finish();
    }

    public void onDestroy() {
        super.onDestroy();
        setModulus();
        finish();
    }

    public boolean onKeyUp(int kc, KeyEvent event) {
        // Detect Done or Enter key press...
        if (kc == KeyEvent.KEYCODE_ENTER) {
            setModulus();
            finish();
            return true;
        } else {
            return false;
        }
    }
}
